# Types.py -- Pamhyr
# Copyright (C) 2023  INRAE
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

# -*- coding: utf-8 -*-

from Model.HydraulicStructures.Basic.HydraulicStructures import (
    BasicHS
)

from Model.HydraulicStructures.Basic.Value import (
    BHSValue
)


class NotDefined(BasicHS):
    def __init__(self, id: int = -1, name: str = "",
                 status=None):
        super(NotDefined, self).__init__(
            id=id, name=name,
            status=status
        )

        self._type = "ND"
        self._data = [
            BHSValue("foo", float, 0.0),
            BHSValue("bar", float, 42.0),
            BHSValue("baz", int, 13),
        ]


class Dummy(BasicHS):
    def __init__(self, id: int = -1, name: str = "",
                 status=None):
        super(Dummy, self).__init__(
            id=id, name=name,
            status=status
        )

        self._type = "DU"
        self._data = [
            BHSValue("foo", float, 0.0),
            BHSValue("bar", float, 42.0),
            BHSValue("baz", int, 13),
        ]


BHS_types = {
    "ND": NotDefined,
    "DU": Dummy,
}
